"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_react_1 = require("mobx-react");
var mobx_1 = require("mobx");
var react_1 = require("react");
exports.SKIP_RERENDER = 'SKIP_RERENDER';
function createContainer(_a) {
    var _b = _a.createStore, createStore = _b === void 0 ? function (props, contextStores) { return null; } : _b, _c = _a.initializeStore, initializeStore = _c === void 0 ? function () { return null; } : _c, _d = _a.mapStoreToProps, mapStoreToProps = _d === void 0 ? function () { return ({}); } : _d, _e = _a.onPropsChange, onPropsChange = _e === void 0 ? function () { return null; } : _e, _f = _a.mapContextStoresToState, mapContextStoresToState = _f === void 0 ? function () { return ({}); } : _f, _g = _a.onContextStoresChange, onContextStoresChange = _g === void 0 ? function () { return exports.SKIP_RERENDER; } : _g, _h = _a.destroyStore, destroyStore = _h === void 0 ? function () { return null; } : _h, contextName = _a.contextName;
    return function (WrappedComponent) {
        var wrappedComponentName = WrappedComponent.displayName || WrappedComponent.name;
        var Container = /** @class */ (function (_super) {
            __extends(Container, _super);
            function Container(props, context) {
                var _this = _super.call(this, props, context) || this;
                _this.state = {
                    store: createStore(props, context.mobxStores),
                    triggerState: false
                };
                onContextStoresChange(_this.state.store, mapContextStoresToState(context.mobxStores));
                onPropsChange(_this.state.store, props);
                return _this;
            }
            Container.prototype.componentWillReceiveProps = function (nextProps) {
                onPropsChange(this.state.store, nextProps);
            };
            // componentWillUnmount is guaranteed to be paired with this
            // we should set up anything that needs to be torn down here
            // instead of relying on createStore
            Container.prototype.componentDidMount = function () {
                var _this = this;
                initializeStore(this.state.store, this.props, this.context.mobxStores);
                this.mobxStoresReactionDisposer = mobx_1.reaction(function () { return mapContextStoresToState(_this.context.mobxStores); }, function (state) {
                    var skipRerender = onContextStoresChange(_this.state.store, state);
                    if (skipRerender === exports.SKIP_RERENDER) {
                        return;
                    }
                    _this.setState({
                        triggerState: !_this.state.triggerState
                    });
                });
            };
            Container.prototype.componentWillUnmount = function () {
                this.mobxStoresReactionDisposer();
                destroyStore(this.state.store, this.props, this.context.mobxStores);
            };
            Container.prototype.render = function () {
                var props = __assign({}, this.props, mapStoreToProps(this.state.store, this.props, this.context.mobxStores));
                var wrappedComponent = react_1.default.createElement(WrappedComponent, __assign({}, props));
                if (contextName) {
                    var providerProps = (_a = {},
                        _a[contextName] = this.state.store,
                        _a);
                    return react_1.default.createElement(mobx_react_1.Provider, __assign({}, providerProps), wrappedComponent);
                }
                return wrappedComponent;
                var _a;
            };
            Container.displayName = wrappedComponentName + "Container";
            Container.contextTypes = {
                mobxStores: mobx_react_1.PropTypes.objectOrObservableObject
            };
            return Container;
        }(react_1.Component));
        return mobx_react_1.observer(Container);
    };
}
exports.default = createContainer;
//# sourceMappingURL=create-mobx-container.js.map