/// <reference types="react" />
import React from 'react';
export declare const SKIP_RERENDER = "SKIP_RERENDER";
export declare type CreateContainerArgs<PropsIn, PropsOut, Store, ContextStores> = {
    createStore?: (props: PropsIn, contextStores: ContextStores) => Store;
    initializeStore?: (store: Store, props: PropsIn, contextStores: ContextStores) => void;
    mapStoreToProps?: (store: Store, props: PropsIn, contextStores: ContextStores) => Partial<PropsOut>;
    onPropsChange?: (store: Store, props: PropsIn) => void;
    mapContextStoresToState?: (contextStore: ContextStores) => any;
    onContextStoresChange?: (store: Store, newState: any) => void | 'SKIP_RERENDER';
    destroyStore?: (store: Store, props: PropsIn, contextStores: ContextStores) => void;
    contextName?: string;
};
export default function createContainer<PropsIn, PropsOut, Store, ContextStores>({createStore, initializeStore, mapStoreToProps, onPropsChange, mapContextStoresToState, onContextStoresChange, destroyStore, contextName}: CreateContainerArgs<PropsIn, PropsOut, Store, ContextStores>): (WrappedComponent: React.ComponentType<PropsIn & PropsOut>) => React.ComponentType<PropsIn>;
